/*
 * Compound.java
 *
 * Created on 23. erven 2007, 9:37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package composer;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 *
 * @author Instal
 */
public class Compound extends DefaultHandler {
    
    int rhythm;
    
    String takt;
    
    List<Tone> tones = new LinkedList();
    
    /** Creates a new instance of Compound */
    public Compound() {
               
    }
    
    File file;
    
    public void load(File file) {
        this.file = file;
        try {
            SAXParser parser = SAXParserFactory.newInstance().newSAXParser();
            
            Main.println("loading "+file.getName());
            
            parser.parse(file, this);
            
            Main.println("loading COMPLETED");
            
        } catch (IOException ex) {
            ex.printStackTrace();
        } catch (SAXException ex) {
            ex.printStackTrace();
        } catch (ParserConfigurationException ex) {
            ex.printStackTrace();
        }
        
    }
    

    public void saveAs(File file) {
        this.file = file;
        try {
            FileWriter fw = new FileWriter(file);
            fw.write(this.toString());
            fw.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    
    
    public void startElement(String uri, String localName, String qName, Attributes attributes) {
        if ("skladba".equals(qName)) {
            takt = attributes.getValue("takt");
            setRhythm(takt);
            Main.println("compound rhythm "+takt+" "+rhythm);
        } else if ("nota".equals(qName)) {
            Tone tone = new Tone();
//            tone.high = Arrays.binarySearch(Tone.tones, attributes.getValue("vyska"));
            tone.setHigh(attributes.getValue("vyska"));
            tone.length = (int)Math.round(Float.parseFloat(attributes.getValue("delka"))/0.5);
            Main.println("tone: "+attributes.getValue("vyska")+" high "+tone.high+" length "+ tone.length/2);
            tones.add(tone);
        } else if ("pomlka".equals(qName)) {
            Tone tone = new Tone();
            tone.pause = true;
            tone.length = (int)Math.round(Float.parseFloat(attributes.getValue("delka"))/0.5);
            tone.title = "_";
            Main.println("pause: length "+tone.length/2);
            tones.add(tone);
        }
    }

    public void setRhythm(String t) {
        if ("3/4".equals(takt)) {
            rhythm = 6;
            this.takt = t;
            
        } else if ("4/4".equals(takt)) {
            rhythm = 8;
            this.takt = t;
            
        } else if ("5/4".equals(takt)) {
            rhythm = 10;
            this.takt = t;            
            
        } else Main.println("unknown takt");
        MainFrame.rhythmField.setText(takt);
        Main.println("new rhythm "+takt);
    }
    
    public String toString() {
        String xml = "<skladba takt=\""+takt+"\">";
        for (Tone tone: tones) {
            xml+=tone.toString();
        }        
        xml+="</skladba>";
        return xml;        
    }
    
    
}
