/*
 * View.java
 *
 * Created on 23. erven 2007, 9:20
 */

package composer;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.HashMap;
import java.util.Map;
import javax.imageio.ImageIO;

/**
 *
 * @author  Instal
 */
public class View extends javax.swing.JPanel implements Runnable {
    
    /** Creates new form View */
    public View() {
        loadTonesImages();
        initComponents();
        new Thread(this).start();
    }
    
    public void run() {
        while (true) {
            try {
                Thread.sleep(50);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            
            repaint();
            
        }
    }
    
    // BufferedImage bi;
    
    Map<String, BufferedImage> images = new HashMap();
    
    String[] imgNames = new String[] {
        "klic", "nota_4", "nota_krizek_4",
        "pomlka_0", "pomlka_1", "pomlka_2", "pomlka_4",
        "nota_nahoru_0", "nota_nahoru_1", "nota_nahoru_2",
        "nota_dolu_0", "nota_dolu_1", "nota_dolu_2",
        "nota_krizek_nahoru_0", "nota_krizek_nahoru_1", "nota_krizek_nahoru_2",
        "nota_krizek_dolu_0", "nota_krizek_dolu_1", "nota_krizek_dolu_2",
        "takt_3", "takt_4", "takt_5"
    };
    
    public void loadTonesImages() {
        
        for (int i = 0; i < imgNames.length; i++) {
            BufferedImage bi1;
            try {
                bi1 = ImageIO.read(this.getClass().getResourceAsStream("/png_pruhledne/" + imgNames[i] + ".png"));
                images.put(imgNames[i], bi1);
            } catch (Exception ex) {
                ex.printStackTrace();
                Main.println("no image: "+imgNames[i]);
            }
            
        }
        
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed

    }//GEN-LAST:event_formKeyPressed

    Tone selectstart = null;
    
    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        for (Tone tone:compound.tones) {
            if ((tone.x0<evt.getX())&&(evt.getX()<tone.x1)) {
                selectstart = tone;
            }
        }
    }//GEN-LAST:event_formMouseClicked
    
    
    
    BufferedImage getImage(String name) {
        BufferedImage bi = images.get(name);
        if (bi==null) Main.println(name + "is null");
        return bi;
    }
    
    Compound compound;
    
    public void setCompound(Compound c) {
        this.compound = c;
        repaint();
        
    }
    
    int y0 = 50, x0 = 0, yd = 3, x=0, ty = 100, y2= 0;
          
    int tact;
    
    public void paint(Graphics g) {
        
        g.setColor(Color.lightGray);
        
        g.fillRect(0, 0, getWidth(), getHeight());
        
        g.setColor(Color.black);
        
        x=0;
        tact = 0;
        for (int i = 0; i < 5; i++) {
            g.drawLine(0, y0-i*2*yd, getWidth(), y0-i*2*yd);
        }
        
        g.drawImage(getImage("klic"), x, y0-35, this);
        
        x+=20;
        if (compound==null) {
            g.drawString("natte sklatbu", 50, ty);
        } else {
            
            g.drawImage(getImage("takt_"+compound.rhythm/2), x, y0-23, this) ;
            x+=20;
            
            int div = 0;
            
            for (Tone tone:compound.tones) {
                tone.x0 = x;
                if (selectstart == tone) {
                    g.setColor(Color.yellow);
                    g.fillRect(x, y0, 20, 20);
                    g.setColor(Color.black);
                }
                if ((div = compound.rhythm-(tact%compound.rhythm))<tone.length) {
                    int ovalsx = x;
//                    Main.println("long tone "+tone.length+" div "+div);
                    int l = tone.length;
                    Tone t = new Tone();
                    t.setHigh(tone.title);
                    t.length = div;
                    t.title = "+";
                    t.pause = tone.pause;
                    drawTone(t, g);   
                    l -= div;
                    while (l>compound.rhythm) {
                        t = new Tone();
                        t.setHigh(tone.title);
                        t.length = compound.rhythm;
                        t.title = "+";
                        t.pause = tone.pause;
                        drawTone(t, g);   
                        l -= compound.rhythm;
          
                    }
                    if (l>0) {
                        t = new Tone();
                        t.setHigh(tone.title);
                        t.length = l;
                        t.title = "+";
                        t.pause = tone.pause;
                        drawTone(t, g);   
                                 
                    }
                    g.drawLine(ovalsx, 10, x-5, 10);
                } else drawTone(tone, g);
                tone.x1 = x;
            }
        }
        
        setPreferredSize(new Dimension(x+100, 100));
    }
    
    void drawTone(Tone tone, Graphics g) {
        String img = (tone.cross)?"nota_krizek_":"nota_";
        if (tone.pause) {
            y2 = -15;
            img = "pomlka_"+tone.length/2;
            if (tone.length==6) img = "pomlka_2";
        } else {
            if (tone.high<7) {
                img +="nahoru_";
                y2 = -15;
            } else {
                img += "dolu_";
                y2 = 3;
            }
            switch (tone.length) {
                case 1: img += "0"; break;
                case 2: img += "1"; break;
                case 3: img += "1"; break;
                case 4: img += "2"; break;
                case 6: img += "2"; break;
                case 8: img = (tone.cross)?"nota_krizek_4":"nota_4"; break;
                default: Main.println("length error "+tone.length);
            }
        }
        
        g.drawImage(getImage(img), x0+x, y0-tone.high*yd+y2, this);
        
        switch (tone.length) {
            case 3: 
            case 6:
                g.fillOval(x+15, y0+y2, 3, 3);
                x+=5;
                break;
        }
        
        g.drawString(tone.title, x, ty);
        x+=20;
        
        tact += tone.length;
        if (tact%compound.rhythm == 0) {
             g.drawLine(x, y0, x, y0-24);
                x+=5;
           }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
